import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;


public class ImageIOTest1 {
    public ImageIOTest1(String filename) {
        File f = new File(filename);

        try {
            BufferedImage image = ImageIO.read(f);

            initFrame(filename, image);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    private void initFrame(String imageName, Image image) {
        JFrame frame = new JFrame(imageName);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        ImageIcon icon = new ImageIcon(image);
        JLabel label = new JLabel(icon);
        
        frame.getContentPane().add(label);
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args){
        if (args.length == 1) {
            new ImageIOTest1(args[0]);
        } else {
            System.out.println("Usage: java ImageIOTest1 <filename>");
        }
    }
}
